﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class plantScript : MonoBehaviour
{
    private float water, temperature, lightLevel, nutrients, drinkrate, nutrientsrate, ideal, weight, refillrate;

    private float maxwater = 3f; // 3 liters

    private bool isAlive;

    public Sprite small, medium, large, witheredSmall, witheredMedium, witheredLarge, wetSmall, wetMedium, wetLarge;
    public Sprite bubbleNone, bubbleWater, bubbleNutrients, bubbleSun, bubbleShade;
    public SpriteRenderer plantRenderer;
    public SpriteRenderer bubbleRenderer;
    public harvestEffect harvestEffect;

    public ParticleSystem growthIndicator;
    private ParticleSystem.EmissionModule growthIndicatorEmission;

    private int framecounter = 0;

    //bool dryState = false;

    // Start is called before the first frame update
    void Start()
    {
        water = Random.Range(0.8f, 1f); ; // liters of water
        temperature = Random.Range(20f,24f); // celcius
        lightLevel = Random.Range(0.8f,1f); // 0 = plant thinks it is too dark, 1 = plant likes the light level, 2 = plant is burning up  
        nutrients = Random.Range(0.8f, 1f); // 0 = plant is starving, 1 = plant has food
        drinkrate = Random.Range(0.4f, 0.5f); // liters per second per kg
        refillrate = Random.Range(1.0f, 1.2f); // liters per second per kg - refill
        nutrientsrate = Random.Range(0.8f, 1f); // nutrients per second per kg
        weight = Random.Range(0.05f, 0.1f); // kg weight
        plantRenderer.sprite = small;
        isAlive = true;
        growthIndicatorEmission = growthIndicator.emission;
        
    }


    void Harvest()
    {

    }

    void UpdateSprite()
    {
        Sprite setSprite = small;

        if (weight < 0.5f)
        {
            if (water > 2f) setSprite = wetSmall;
            else if (water < .2f) setSprite = witheredSmall;
            else setSprite = small;
        }

        else if (weight < 1.0f)
        {
            if (water > 2f) setSprite = wetMedium;
            else if (water < .2f) setSprite = witheredMedium;
            else setSprite = medium;
        }
        else 
        {
            if (water > 2f) setSprite = wetLarge;
            else if (water < .2f) setSprite = witheredLarge;
            else setSprite = large;
        }
        if (plantRenderer.sprite != setSprite) plantRenderer.sprite = setSprite;

    }

    public bool GiveNutrients()
    { 
        if (nutrients > 0.9) return false;
        nutrients += .5f;
        return true;
    }

    void UpdateBubble()
    {
        Sprite setSprite = bubbleNone;

        if (water < 0.5f && isAlive)  setSprite = bubbleWater;
        else if (lightLevel > 1.8f && isAlive) setSprite = bubbleShade;
        else if (nutrients < 0.5f && isAlive) setSprite = bubbleNutrients;
        else if (lightLevel < 0.2f && isAlive) setSprite = bubbleSun;
        

        if (bubbleRenderer.sprite != setSprite) bubbleRenderer.sprite = setSprite;


    }

    // Update is called once per frame
    void Update()
    {
        framecounter++;

        drinkrate = weight / 10f;
        nutrientsrate = weight / 10f;
        water -= drinkrate * Time.deltaTime;
        if (water < 0f)
        {
            water = 0f;
            weight = 0.0f;
        }
        nutrients -= nutrientsrate * weight * Time.deltaTime;
        if (nutrients < 0f) nutrients = 0f;

        if(isAlive)
            weight += water * nutrients * lightLevel * Time.deltaTime / 50f;

        growthIndicatorEmission.rateOverTime = water * nutrients * lightLevel * 10f;

        if (weight < 0.1f) weight = 0.1f;
        if (weight > 1.05f)
        {
            harvestEffect.TriggerHavestEffect();
            weight = 0.1f;
        }

        if (framecounter++ > 1000)
        {
            Debug.Log("Water: " + water + " Weight: " + weight + " Nutrients: " + nutrients + " LightLevel: " + lightLevel + " Temperature: " + temperature);
            framecounter = 0;
        }
        
        if (transform.parent.GetComponent<workbenchElementScript>().elementId > 10) // in the sun
        {
            lightLevel += 0.1f * Time.deltaTime;
            if (lightLevel > 2f) lightLevel = 2f;
        }
        else
        {
            lightLevel -= 0.02f * Time.deltaTime;
            if (lightLevel < 0f) lightLevel = 0f;
        }
        
        if (transform.parent.tag == "Sink")
        {
            if (isAlive)
            {
                water += refillrate * Time.deltaTime;
                if (water > maxwater) water = maxwater;
            }
        }
        if (water < .2f) isAlive = false;

        UpdateSprite();
        UpdateBubble();

    }
}
