﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class playerController : MonoBehaviour
{
    public GameObject workbench;

    private float xpos = 0.0f;
    private float xvel = 0.0f;
    //private float xacc = 0.0f;
    private float xposLimit = 7.0f;
    private float xvelLimit = 6.0f;
    private float playerAcceleration = 25.0f;
    private float playerFriction = 25.0f;
    private float playerActionCooldownTimer = 0.0f;
    private float playerActionCooldownTimerLimit = 0.1f;
    private int movementInputDirectionX = 0; // -1 = move left, 0 = no movement, 1 = move right

    public GameObject bag;

    //private bool carryingSomething = false;

    // Start is called before the first frame update
    void Start()
    {
        GlobalStorage.Score = 0;
        GlobalStorage.CurrentTime = 0;
    }

    public void CanvasButtonLeftDown() 
    {
        movementInputDirectionX = -1;
    }
    public void CanvasButtonLeftUp()
    {
        movementInputDirectionX = 0;
    }
    public void CanvasButtonRightDown()
    {
        movementInputDirectionX = 1;
    }
    public void CanvasButtonRightUp()
    {
        movementInputDirectionX = 0;
    }
    public void CanvasButtonUseDown()
    {
        ManagePlayerUseAction();

    }
    public void CanvasButtonUseUp()
    {
    }

    void ManageUseItem(GameObject itemCarried)
    {
        int xposition = (int)Mathf.Round(xpos);

        // 0 = standard bench, 1 = water source, 2 = window control, 3 = heater control, 4 = fertilizer pile, 9 = no bench
        int closestWorkbenchType = workbench.GetComponent<workbenchScript>().QueryWorkbenchType(xposition);

        if (closestWorkbenchType == 0 || closestWorkbenchType == 1) // bench or water source
        {
            bool success = workbench.GetComponent<workbenchScript>().QueryWorkbenchContent(xposition).GetComponent<workbenchElementScript>().applyGameObjectOnTile(itemCarried);

            if (success) // item used
            {
                Debug.Log("item used");
            }
        }


    }

    void ManageGetItem()
    {
        int xposition = (int)Mathf.Round(xpos);

        // 0 = standard bench, 1 = water source, 2 = window control, 3 = heater control, 4 = fertilizer pile, 9 = no bench
        int closestWorkbenchType = workbench.GetComponent<workbenchScript>().QueryWorkbenchType(xposition);

        if (closestWorkbenchType == 0 || closestWorkbenchType == 1) // bench or water source
        {
            GameObject item = workbench.GetComponent<workbenchScript>().QueryWorkbenchContent(xposition).GetComponent<workbenchElementScript>().getItemFromTile();

            if (item != null) // check for item
            {
                item.transform.parent = gameObject.transform;
                item.transform.localPosition = Vector3.zero;
                foreach (Transform child in item.transform)
                {
                    if (child.GetComponent<SpriteRenderer>() != null)
                    {
                        child.GetComponent<SpriteRenderer>().sortingLayerName = "Item in Hand";

                    }
                }


                item.GetComponent<SpriteRenderer>();
            }
        }
        if (closestWorkbenchType == 6) // pile of bags
        {
            GameObject newBag = Instantiate(bag);
            newBag.transform.parent = gameObject.transform;
            newBag.transform.localPosition = Vector3.zero;
        }
    }

    void ManagePlayerUseAction()
    {
        if (playerActionCooldownTimer>playerActionCooldownTimerLimit)
        {
            GameObject itemCarried = null;

            foreach (Transform child in transform)
            {
                if (child.tag == "Pot" || child.tag == "Bag")
                { 
                    itemCarried = child.gameObject;
                }
            }

            if(itemCarried == null)
            {
                ManageGetItem();
            }
            else
            {
                ManageUseItem(itemCarried);
            }
            playerActionCooldownTimer = 0f;
        }
    }



    void MangeInputKeyboard()  // todo: manage pressing both left and right (it is set to 0 when it should not)
    {
        if (Input.GetKeyDown("right")) movementInputDirectionX = 1;
        if (Input.GetKeyDown("left")) movementInputDirectionX = -1;

        if (Input.GetKeyUp("right")) movementInputDirectionX = 0;
        if (Input.GetKeyUp("left")) movementInputDirectionX = 0;

        if (Input.GetKeyDown("space")) ManagePlayerUseAction();

    }


    void AddAcceration()
    {
        if (movementInputDirectionX == 1) xvel += playerAcceleration * Time.deltaTime;
        else if (movementInputDirectionX == -1) xvel -= playerAcceleration * Time.deltaTime;

        if (xvel > xvelLimit) xvel = xvelLimit;
        if (xvel < -xvelLimit) xvel = -xvelLimit;

        xpos += xvel * Time.deltaTime;
    }

    void AddFriction()
    {
        if (movementInputDirectionX == 0)
        {
            xvel -= xvel * (playerFriction * Time.deltaTime);
        }
    }

    void LimitArea()
    {
        // make sure the player is where it is allowed to be
        if (xpos > xposLimit)
        {
            xpos = xposLimit;
            xvel = 0.0f;
            //xacc = 0.0f;
        }
        if (xpos < -xposLimit)
        {
            xpos = -xposLimit;
            xvel = 0.0f;
            //xacc = 0.0f;
        }
    }

    void UpdatePlayerPosition()
    {
        transform.position = new Vector3(xpos, 0.0f, 0.0f);
    }

    // Update is called once per frame
    void Update()
    {
        playerActionCooldownTimer += Time.deltaTime;
        MangeInputKeyboard();
        //Canvas button manage themselves
        AddAcceration();
        AddFriction();
        LimitArea();
        UpdatePlayerPosition();

        GlobalStorage.CurrentTime += Time.deltaTime;

        float timerPosition = 0f;

        var progressBar = GlobalStorage.CurrentTime / GlobalStorage.EndTime; // how much of the season has passed



        timerPosition = (400f * progressBar) - 200f;

        GameObject.FindGameObjectsWithTag("Timer")[0].GetComponent<RectTransform>().anchoredPosition = new Vector3(timerPosition, -25f,0f);

        if(GlobalStorage.CurrentTime > GlobalStorage.EndTime) SceneManager.LoadScene("Score");

    }
}
