﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public class workbenchScript : MonoBehaviour
{
    public GameObject bench;
    public GameObject sink;
    public GameObject pot;
    public GameObject bags;
    private float GameSpaceOffset = 8.0f;

    public int QueryWorkbenchType(int position)
    {
        position += (int)GameSpaceOffset;
        return workbenchElements[position].type; 
    }

    public GameObject QueryWorkbenchContent(int position)
    {
        position += (int)GameSpaceOffset;

        if (workbenchElements[position].item != null)
            return workbenchElements[position].item;

        return null;
    }

    private struct workbenchElement
    {
        public int xpos; // 16 wide
        public GameObject item;
        public int type; // 0 = standard bench, 1 = water source, 2 = window control, 3 = heater control, 4 = fertilizer pile, 5 = bench and pot, 6 = manure, 9 = no bench

        public workbenchElement(int x, GameObject b, int y)
        {
            xpos = x;
            item = b;
            type = y;
        }
    }
    private workbenchElement[] workbenchElements; 
/* 
    void InstantiateBench()
    {
        Debug.Log(workbenchElements.Length);
        
    
    }
*/

    // Start is called before the first frame update
    void Start()
    {
        //workbenchElement[] 
        workbenchElements = new workbenchElement[] {
            new workbenchElement(0, null, 9),
            new workbenchElement(1, null, 6),
            new workbenchElement(2, null, 1), // water source
            new workbenchElement(3, null, 1),
            new workbenchElement(4, null, 5), 
            new workbenchElement(5, null, 5),
            new workbenchElement(6, null, 0), 
            new workbenchElement(7, null, 5), 
            new workbenchElement(8, null, 0),
            new workbenchElement(9, null, 5),
            new workbenchElement(10, null, 0), 
            new workbenchElement(11, null, 0),
            new workbenchElement(12, null, 0),
            new workbenchElement(13, null, 0),
            new workbenchElement(14, null, 9),
            new workbenchElement(15, null, 6),
            new workbenchElement(16, null, 9)
        };
        for(int i = 0; i < workbenchElements.Length; i++)
        {
            if(workbenchElements[i].type == 0)
            {
                GameObject newObject = Instantiate(bench, new Vector3(workbenchElements[i].xpos-GameSpaceOffset, -1.0f, 0.0f), Quaternion.identity);
                newObject.transform.parent = gameObject.transform;
                newObject.GetComponent<workbenchElementScript>().elementId = i;
                workbenchElements[i].item = newObject;
            } 
            else if(workbenchElements[i].type == 1)
            {
                GameObject newObject = Instantiate(sink, new Vector3(workbenchElements[i].xpos-GameSpaceOffset, -1.0f, 0.0f), Quaternion.identity);
                newObject.transform.parent = gameObject.transform;
                newObject.GetComponent<workbenchElementScript>().elementId = i;
                workbenchElements[i].item = newObject;
            }
            else if (workbenchElements[i].type == 5)
            {
                GameObject newObject = Instantiate(bench, new Vector3(workbenchElements[i].xpos - GameSpaceOffset, -1.0f, 0.0f), Quaternion.identity);
                newObject.transform.parent = gameObject.transform;
                newObject.GetComponent<workbenchElementScript>().elementId = i;
                workbenchElements[i].item = newObject;

                GameObject newPot = Instantiate(pot, new Vector3(workbenchElements[i].xpos - GameSpaceOffset, -1.0f, 0.0f), Quaternion.identity);
                newPot.transform.parent = newObject.transform;
                
                workbenchElements[i].type = 0; // Change to bench after placing pot
            }
            else if (workbenchElements[i].type == 6)
            {
                GameObject newObject = Instantiate(bags, new Vector3(workbenchElements[i].xpos - GameSpaceOffset, -1.0f, 0.0f), Quaternion.identity);
                newObject.transform.parent = gameObject.transform;
                //newObject.GetComponent<workbenchElementScript>().elementId = i;
                workbenchElements[i].item = newObject;
            }
        }

       //InstantiateBench();
    }

    // Update is called once per frame
    void Update()
    {
        
    }
}
